#ifndef __UART_QUEUE_H
#define __UART_QUEUE_H

/* Includes */

#include "hw_config.h"
#include "global_types.h"

/* Exported constants */

/* Exported functions */

void UartQueue_Initialize(void);

// UART 2 Queue for Comm

bool Uart_2_Queue_Comm_Is_Empty(void);
uint32_t Uart_2_Queue_Comm_CurrSize(void);
void Uart_2_Queue_Comm_EnQueue(uint16_t data);
uint16_t Uart_2_Queue_Comm_DeQueue(void);

// UART 3 Queue for Comm

bool Uart_3_Queue_Comm_Is_Empty(void);
uint32_t Uart_3_Queue_Comm_CurrSize(void);
void Uart_3_Queue_Comm_EnQueue(uint16_t data);
uint16_t Uart_3_Queue_Comm_DeQueue(void);

// UART Queue for Serial

bool UartQueue_Serial_Is_Empty(void);
void UartQueue_Serial_EnQueue(uint16_t data);
uint16_t UartQueue_Serial_DeQueue(void);

#endif /* __UART_QUEUE_H */

